//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@yɃZsAtB^ v0.4
//@@@by iuser/5145841j
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@[U[p[^

//@mNASYw
//@@0:ϊȂ@1:ώZo@@2:BT.601(NTSC)x[X@3:BT.709(HDTV)x[XiftHgj
#define MONO_ALGO 3
//@BT.709x[XŃmNۂɗpK}li{: 2.2Al͈: 1.0`3.0j
#define GAMMA 2.2

//@ȈՐF␳i , , i,j̏ɎwA1ŕωȂj
//@@ݒ 1.0, 1.0, 1.0, 1.0
float4 ColorFilter
<
   string UIName = "ColorFilter";
   string UIWidget = "Color";
   bool UIVisible =  true;
   float UIMin = float4( 0, 0, 0, 1);
   float UIMax = float4( 2, 2, 2, 1);
> = float4( 1.0, 1.0, 1.0, 1.0 );


float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;

//@XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;

static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);

//@}eAF
float4 MaterialDiffuse : DIFFUSE  < string Object = "Geometry"; >;
static float alpha = MaterialDiffuse.a;

float scaling0 : CONTROLOBJECT < string name = "(self)"; >;
static float scaling = scaling0 * 0.1;

float3 ObjXYZ0 : CONTROLOBJECT < string name = "(self)"; >;
static float3 ObjXYZ = ObjXYZ0 + 1.0;

//@_O^[Qbg̃NAl
float4 ClearColor = {1,1,1,1};
float ClearDepth  = 1.0;

//@g[␳pvZbgrbg}bv
texture2D Tone <
	string ResourceName = "{W\\ZsA.bmp";
	int MipLevels = 1;
	string Format = "A8R8G8B8" ;
>;
sampler ToneSamp = sampler_state{
	Texture = <Tone>;
	MinFilter = NONE;
	MagFilter = NONE;
	MipFilter = NONE;
	AddressU  = CLAMP;
	AddressV = CLAMP;
};

//@[xobt@
texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = {1.0,1.0};
	string Format = "D24S8";
>;

//@IWi̕`挋ʂL^邽߂̃_[^[Qbg
texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = {1.0,1.0};
	int MipLevels = 1;
	string Format = "A8R8G8B8" ;
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = NONE;
	MagFilter = NONE;
	MipFilter = NONE;
	AddressU  = CLAMP;
	AddressV = CLAMP;
};

#if MONO_ALGO == 2	//@PxZo@iBT601:NTSCj
static const float3 LumiFactor = {0.29891, 0.58661, 0.11448};

#elif MONO_ALGO == 3	//@PxZo@iBT709:HDTVj
static const float3 LumiFactor = {0.2126, 0.7152, 0.0722};
#endif
	
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@_VF[_
struct VS_OUTPUT {
	float4 Pos			: POSITION;
	float2 Tex			: TEXCOORD0;
};

VS_OUTPUT VS_passDraw( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
	VS_OUTPUT Out = (VS_OUTPUT)0; 
	
	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	
	return Out;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@vZbgrbg}bvɐF̒u

float4 PS_passTonemap(float2 Tex: TEXCOORD0) : COLOR
{   
	float4 Color;		//@̃sNZJ[i[
	float4 ColorOrg;	//@ÕsNZJ[i[

	Color = tex2D( ScnSamp, Tex );
	ColorOrg = Color;

	//@R,G,B ɋ߂PxămN
#if MONO_ALGO == 1		//@ώZo@
	Color.rgb = (Color.r + Color.g + Color.b) * 0.33333333;

#elif MONO_ALGO == 2	//@PxZo@iBT601:NTSCj
	Color.rgb = dot(LumiFactor, Color.rgb);

#elif MONO_ALGO == 3	//@PxZo@iBT709:HDTVj
	Color.rgb = pow(Color.rgb, GAMMA);
	Color.rgb = pow(dot(LumiFactor, Color.rgb), 1.0 / GAMMA);
#endif

	Color.r = tex2D( ToneSamp, float2(Color.r, 0)).r;
	Color.g = tex2D( ToneSamp, float2(Color.g, 0)).g;
	Color.b = tex2D( ToneSamp, float2(Color.b, 0)).b;

	//@F␳ʂÂɔႳč
    Color.rgb = lerp(Color.rgb, Color.rgb * ColorFilter.rgb * ObjXYZ, 1 - Color.rgb);

	//@ANZT̕sxɃIWiƍ
	return lerp(ColorOrg, Color, alpha);
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
technique Diffusion <
	string Script = 
		
		"RenderColorTarget0=ScnMap;"
		"RenderDepthStencilTarget=DepthBuffer;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"ScriptExternal=Color;"
		
		"RenderColorTarget0=;"
		"RenderDepthStencilTarget=;"
		"ClearSetColor=ClearColor;"
		"ClearSetDepth=ClearDepth;"
		"Clear=Color;"
		"Clear=Depth;"
		"Pass=TonemapExec;"
	;
	
> {
	pass TonemapExec < string Script= "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_2_0 VS_passDraw();
		PixelShader  = compile ps_2_0 PS_passTonemap();
	}
}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
